
/*

  MobilePhone plugin
  
    Show Missed Calls and Voicemails
    
*/

CallsPhone = new Plugin('calls:phone')
CallsPhone.bundleIdentifier = 'com.ashman.lockinfo.PhonePlugin';

CallsPhone.callback = function(data) {
  if (data.calls)
    this.callback_phone(data);
};

CallsPhone.callback_phone = function(data) {
  
  this.Design.clean();
  this.nowExpand = false;
  
  var calls = data.calls;
  var currentDate;
  if (calls.length > 0) {
    var maxExpanded = (((Settings.allowExpand) && (this.Settings.allowExpand))?((this.Settings.maxCallsExpanded == 0)?calls.length:this.Settings.maxCallsExpanded):((this.Settings.defCallsState == 'shrinked')?this.Settings.maxCalls:this.Settings.maxCallsExpanded));
	  var countStr = ((maxExpanded < calls.length)?maxExpanded+'/'+calls.length:calls.length);
	  
    var div = this.Design.generateCustom('','calls-content','calls');
    
    // Add Missed calls header
    div.appendChild(this.Design.generateHeader((Settings.nbBefore)?countStr+' '+((calls.length > 1)?$L('Missed Calls'):$L('Missed Call')):((calls.length > 1)?$L('Missed Calls'):$L('Missed Call'))+': '+countStr,'calls'));
    
    for (i = 0; i < calls.length && i < maxExpanded; i++) {
      
      //Create the hidden div if over limit
      if((i >= this.Settings.maxCalls) && (!this.nowExpand)) {
        this.Design.appendCustom(div);
        div = div.appendChild(this.Design.generateCustom('','calls-content','calls-expand'));
        div.style.display = (this.Settings.defCallsState == 'shrinked' && !this.expanded)?'none':'block';
        this.expanded = (!(this.Settings.defCallsState == 'shrinked' && !this.expanded));
        this.nowExpand = true;
      }
      
      
      //Add Date
      date = new Date();
      date.setTime(calls[i].date);
      
      if ((!this.Settings.groupCalls) && (currentDate == null || date.isDifferentDay(currentDate))) {
        if(date.isToday())
          div.appendChild(this.Design.generateHeader($L('Today'), 'dayHeader'));
        else if(date.isYesterday())
          div.appendChild(this.Design.generateHeader($L('Yesterday'), 'dayHeader'));
        else
          div.appendChild(this.Design.generateHeader(date.format($S('longDate')), 'dayHeader'));
        
        currentDate = date;
      }
      
      //Adding Caller name
      if (calls[i].caller == "Unknown")
        var callerName = $L('Unknown');
      else
        var callerName = calls[i].caller;
      
      div.appendChild(this.Design.generateSummary(callerName,(i == 0 ? "firstItem" : "")));
      
      if(!this.Settings.groupCalls)
        div.appendChild(this.Design.generateLocation((Settings.useRelative)?date.relative():date.format($S('formatTime'))));
      else if (date.isToday())
        div.appendChild(this.Design.generateLocation($L('Today')+" "+$S('dateDivider')+' '+((Settings.useRelative)?date.relative():date.format($S('formatTime')))));
      else if (date.isYesterday())
        div.appendChild(this.Design.generateLocation($L('Yesterday')+" "+$S('dateDivider')+' '+((Settings.useRelative)?date.relative():date.format($S('formatTime')))));
      else
        div.appendChild(this.Design.generateLocation(date.format($S('formatDate'))+" "+$S('dateDivider')+' '+((Settings.useRelative)?date.relative():date.format($S('formatTime')))));
    }
    
    this.Design.appendCustom(div);
    
    if(this.nowExpand) {
      this.Design.appendCustom('. . .','expand');
      this.expandable = 'calls-expand';
      
      this.setToggle();
		}
  }
};

Controller.registerPlugin(CallsPhone);




var CallsVoice = new Plugin('calls:voicemail');
CallsVoice.bundleIdentifier = 'com.ashman.lockinfo.PhonePlugin';

CallsVoice.expandable = 'voicemail-expand';

CallsVoice.callback = function(data) {
  if (data.voicemail)
    this.callback_voicemail(data);
};

CallsVoice.callback_voicemail = function(data) {
  
  this.Design.clean();
  this.nowExpand = false;
  
  var vm = data.voicemail;
  var currentDate;
  if (vm.length > 0) {
    var maxExpanded = (((Settings.allowExpand) && (this.Settings.allowExpand))?((this.Settings.maxVoicemailExpanded == 0)?vm.length:this.Settings.maxVoicemailExpanded):((this.Settings.defVoicemailState == 'shrinked')?this.Settings.maxVoicemail:this.Settings.maxVoicemailExpanded));
    
    var countStr = ((maxExpanded < vm.length)?maxExpanded+'/'+vm.length:vm.length);
    
    //Add header
    var div = this.Design.generateCustom('','voicemail-content','voicemail');
    div.appendChild(this.Design.generateHeader($L('Voicemail')+": "+countStr));
		
		for (i = 0; i < vm.length && i < maxExpanded; i++) {
		  
		  if((i >= this.Settings.maxVoicemail) && (!this.nowExpand)) {
        this.Design.appendCustom(div);
        div = div.appendChild(this.Design.generateCustom('','voicemail-content','voicemail-expand'));
        div.style.display = (this.Settings.defVoicemailState == 'shrinked' && !this.expanded)?'none':'block';
        this.expanded = (!(this.Settings.defVoicemailState == 'shrinked' && !this.expanded));
        this.nowExpand = true;
      }
      
      
			date = new Date();
			date.setTime(vm[i].date);
      
      if ((!this.Settings.groupVoicemails) && (currentDate == null || date.isDifferentDay(currentDate))) {
        if(date.isToday())
          div.appendChild(this.Design.generateHeader($L('Today'), 'dayHeader'));
        else if(date.isYesterday())
          div.appendChild(this.Design.generateHeader($L('Yesterday'), 'dayHeader'));
        else
          div.appendChild(this.Design.generateHeader(date.format($S('longDate')), 'dayHeader'));
        
        currentDate = date;
      }
      
      //Add Caller ID
      div.appendChild(this.Design.generateSummary(vm[i].caller,(i == 0 ? "firstItem" : "")));
      
			
			//Add Date
      if(!this.Settings.groupVoicemails)
        div.appendChild(this.Design.generateLocation((Settings.useRelative)?date.relative():date.format($S('formatTime'))));
      else if (date.isToday())
        div.appendChild(this.Design.generateLocation($L('Today')+" "+$S('dateDivider')+' '+((Settings.useRelative)?date.relative():date.format($S('formatTime')))));
      else if (date.isYesterday())
        div.appendChild(this.Design.generateLocation($L('Yesterday')+" "+$S('dateDivider')+' '+((Settings.useRelative)?date.relative():date.format($S('formatTime')))));
      else
        div.appendChild(this.Design.generateLocation(date.format($S('formatDate'))+" "+$S('dateDivider')+' '+((Settings.useRelative)?date.relative():date.format($S('formatTime')))));
			
		}
		
		this.Design.appendCustom(div);
		
		if(this.nowExpand) {
      this.Design.appendCustom('. . .','expand');
		  
      this.setToggle();
		}
	}
};


Controller.registerPlugin(CallsVoice);
