/*

  Clock plugin
  
    Show date/time
    
*/

var Clock = new Plugin('clock');

Clock.onload = function() {
  
  this.dateFormat = (this.Settings.dateFormat == 'default')?$S('longDate'):this.Settings.dateFormat;
  this.timeFormat = (this.Settings.timeFormat == 'default')?$S('formatTime'):this.Settings.timeFormat;
  
  if(Settings.plugins[0] == 'clock')
    $('background').className += ' clockontop';
  
  var now = new Date();
  
  this.Design.clean();
  
  var classNames = [];
  if(this.Settings.doubleBar)
    classNames.push('double');
  
  var header = this.Design.generateHeader('', classNames);
  header.appendChild(this.Design.generateCustom(now.format(this.dateFormat), 'date', null, 'span'));
  header.appendChild(this.Design.generateCustom(now.format(this.timeFormat), 'time', null, 'span'));
  this.Design.appendCustom(header, classNames);
  
  window.setTimeout(this.update.bind(this), 1000);
};

Clock.update = function() {
  this.Design.clean();
  
  var now = new Date();
  
  var classNames = [];
  if(this.Settings.doubleBar)
    classNames.push('double');
  
  if(this.Settings.fixed)
    classNames.push('fixed');
  
  var header = this.Design.generateHeader('', classNames);
  header.appendChild(this.Design.generateCustom(now.format(this.dateFormat), 'date', null, 'span'));
  header.appendChild(this.Design.generateCustom(now.format(this.timeFormat), 'time', null, 'span'));
  this.Design.appendCustom(header, classNames);
  
  window.setTimeout(this.update.bind(this), 1000);
};


Controller.registerPlugin(Clock);
