
/*

  Status Notifier plugin
    
*/

var Status = new Plugin('statusnotifier');

Status.processXml = function(xmlReq)
{
   
    if (xmlReq.readyState != 4) 
        return;
    
    if (xmlReq.status != 200 && xmlReq.status != 0) 
        return;
    
    var root = xmlReq.responseXML;
    
    var silent = eval('({"bundleIdentifier": "com.statusnotifier.silent", "enabled": '+((root.getElementsByTagName("Silent")[0].firstChild.nodeValue == 1)?'true':'false')+'})');
    updateView(silent.bundleIdentifier, silent);
    
    var rss = eval('({"bundleIdentifier": "com.statusnotifier.rss", "count": '+parseInt(root.getElementsByTagName("RSS")[0].firstChild.nodeValue)+'})');
    updateView(rss.bundleIdentifier, rss);
    
    var mms = eval('({"bundleIdentifier": "com.statusnotifier.mms", "count": '+parseInt(root.getElementsByTagName("MMS")[0].firstChild.nodeValue)+'})');
    updateView(mms.bundleIdentifier, mms);
    
    var im = eval('({"bundleIdentifier": "com.statusnotifier.im", "count": '+parseInt(root.getElementsByTagName("IM")[0].firstChild.nodeValue)+'})');
    updateView(im.bundleIdentifier, im);
}

Status.updateStatusNotifier = function()
{
    var xmlReq = new XMLHttpRequest();
    xmlReq.onreadystatechange = function(){Status.processXml(xmlReq);};
    xmlReq.overrideMimeType("text/xml");
    xmlReq.timeout = 2000;
    xmlReq.open("GET", "http://127.0.0.1:16322/status", true);
    xmlReq.send();
    
    setTimeout(Status.updateStatusNotifier, 10*1000);
};

Controller.registerPlugin(Status,true);


var StatusSilent = new Plugin('status:silent');
StatusSilent.bundleIdentifier = 'com.statusnotifier.silent';

StatusSilent.callback = function(data) {
  this.Design.clean();
  
  if(data.enabled)
    this.Design.appendHeader($L('Silent Mode'), ['statusnotifier','silent']);
};

Controller.registerPlugin(StatusSilent);



var StatusRSS = new Plugin('status:rss');
StatusRSS.bundleIdentifier = 'com.statusnotifier.rss';

StatusRSS.callback = function(data) {
  this.Design.clean();
  
  if(data.count > 0)
    this.Design.appendHeader($L('RSS')+': '+data.count, ['statusnotifier','rss']);
};

Controller.registerPlugin(StatusRSS);


var StatusMMS = new Plugin('status:mms');
StatusMMS.bundleIdentifier = 'com.statusnotifier.mms';

StatusMMS.callback = function(data) {
  this.Design.clean();
  
  if(data.count > 0)
    this.Design.appendHeader((Settings.nbBefore)?data.count+' '+$L('MMS'):$L('MMS')+': '+data.count, ['statusnotifier','mms']);
};

Controller.registerPlugin(StatusMMS);


var StatusIM = new Plugin('status:im');
StatusIM.bundleIdentifier = 'com.statusnotifier.im';

StatusIM.callback = function(data) {
  this.Design.clean();
  
  if(data.count > 0)
    this.Design.appendHeader($L('IM')+': '+data.count, ['statusnotifier','im']);
};

Controller.registerPlugin(StatusIM);


Status.updateStatusNotifier();
