/*

  Weather plugin
  
    Show current weather and 6 days forecast
    
*/
//console.log('loading weather...');

var Weather = new Plugin('weather');

Weather.expandable = 'Forecast';
Weather.postal = '';
Weather.daysCode = ['Sunday', 'Monday', 'Tuesday', 'Wednesday', 'Thursday', 'Friday', 'Saturday'];
Weather.nbTry = 0;
Weather.neverUpdated = true;

Weather.onload = function() {
	Source.validateWeatherLocation(escape(Settings.weather.locale).replace(/^%u/g, "%"), Weather.setPostal);
};

Weather.setPostal = function(obj) {
  
  if (obj.error == false){
		if(obj.cities.length > 0){
			Weather.postal = escape(obj.cities[0].zip).replace(/^%u/g, "%");	
			Weather.weatherRefresherTemp();
		}else {
		  Weather.Design.clean();
		  Weather.Design.appendHeader($L('Not Found'), 'error');
		}
	}
  else {
    Weather.Design.clean();
    Weather.Design.appendHeader($L(obj.errorString), 'error');	
		setTimeout('Source.validateWeatherLocation(escape(Settings.weather.locale).replace(/^%u/g, "%"), Weather.setPostal)', Math.round(1000*60*5));
	}
};

Weather.weatherRefresherTemp = function() {
  Source.fetchWeatherData(Weather.dealWithWeather,Weather.postal);
};

Weather.dealWithWeather = function(obj) {
  
	if (obj.error == false) {
	  Weather.Design.clean();
	  
	  var header = Weather.Design.generateHeader(''); 
	  
	  var icon = document.createElement('img');
	  icon.className = 'weatherIcon';
    icon.src="plugins/weather/Icon Sets/"+Settings.weather.iconSet+"/"+Source.MiniIcons[obj.icon]+Settings.weather.iconExt;
    
    header.appendChild(icon);
	  
	  var city = Weather.Design.generateCustom(obj.city.toLowerCase(), 'city', null, 'span');
	  city.style.textTransform='capitalize';
	  header.appendChild(city);
	  
    if(Settings.weather.useRealFeel == true){
			tempValue = Weather.convertTemp(obj.realFeel);
		}else{
			tempValue = Weather.convertTemp(obj.temp)
		}
		
	  header.appendChild(Weather.Design.generateCustom(tempValue+"º", 'temp', null, 'span'));
				
	  var desc = Weather.Design.generateCustom($L(obj.description.toUpperCase()).toLowerCase(), 'desc', null, 'span');
	  desc.style.textTransform='capitalize';
	  header.appendChild(desc);
		
		Weather.Design.appendCustom(header);
		
		
		lastResults = new Array;
		lastResults[0] = {daycode:obj.daycode, icon:obj.icon, hi:obj.hi, lo:obj.lo, now:obj.temp};
		var c = obj.forecast.length;
		if (c > 6) c = 6; // just to be safe
		var i = 0;
		
		var Forecast = Weather.Design.appendCustom('','Forecast','Forecast');
		
		if((Weather.Settings.inlineForecast) || ((c<4) && (Weather.Settings.autoInline))) {
		  c=((c > Weather.Settings.inlineLimit)?Weather.Settings.inlineLimit:c);
		  
  		while (i < c && obj.forecast[i])
  		{
  			var forecast = obj.forecast[i];
  			
  		  if(i == 0 && forecast.daycode != new Date().getDay()) {
  		    i++;
  		    c++;
  		    continue;
  		  }
  		  
  		  var days = document.createElement('div');
  		  days.className = 'dayD';
  		  
        
        var iconD = document.createElement('div');
        iconD.className = 'icon';
        
        var icon = document.createElement('img');
        icon.src = "plugins/weather/Icon Sets/"+Settings.weather.iconSet+"/"+Source.MiniIcons[forecast.icon]+Settings.weather.iconExt;
        
        iconD.appendChild(icon);
        
        days.appendChild(iconD);
        
        var day = document.createElement('div');
        day.className = 'day';
        day.innerText = $L(Weather.daysCode[forecast.daycode].ucfirst());
        days.appendChild(day);
        
        var desc = document.createElement('div');
        desc.className = 'desc';
        desc.innerText = $L(forecast.description.toUpperCase()).toLowerCase();
        desc.style.textTransform = 'capitalize';
        days.appendChild(desc);
        
        var tempD = document.createElement('div');
        tempD.className = 'temp';
        
        var hi = document.createElement('div');
        hi.className='hi';
        hi.innerText = Weather.convertTemp(forecast.hi)+"º";
        
        tempD.appendChild(hi);
        
        var low = document.createElement('div');
        low.className='low';
        low.innerText = Weather.convertTemp(forecast.lo)+"º";
        
        tempD.appendChild(low);
        
        days.appendChild(tempD)
        
        Forecast.appendChild(days);
  			lastResults[i++] = {daycode:forecast.daycode, icon:forecast.icon, hi:forecast.hi, lo:forecast.lo};
  		}
    }
    else {
  		var days = Forecast.appendChild(document.createElement('div'));
  		var icons = Forecast.appendChild(document.createElement('div'));
  		var temps = Forecast.appendChild(document.createElement('div'));
  		
  		while (i < c && obj.forecast[i])
  		{
  			var forecast = obj.forecast[i];
  			
  		  if(i == 0 && forecast.daycode != new Date().getDay()) {
  		    i++;
  		    c++;
  		    continue;
  		  }
        
        var day = document.createElement('div');
        day.className = 'day';
        day.innerText = $L(Weather.daysCode[forecast.daycode].substring(0,3).toLowerCase().ucfirst()).toUpperCase()
        days.appendChild(day);
        
        var iconD = document.createElement('div');
        iconD.className = 'icon';
        
        var icon = document.createElement('img');
        icon.src = "plugins/weather/Icon Sets/"+Settings.weather.iconSet+"/"+Source.MiniIcons[forecast.icon]+Settings.weather.iconExt;
        
        iconD.appendChild(icon);
        
        icons.appendChild(iconD);
        
        var tempD = document.createElement('div');
        tempD.className = 'temp';
        
        var hi = document.createElement('div');
        hi.className='hi';
        hi.innerText = Weather.convertTemp(forecast.hi)+"º";
        
        tempD.appendChild(hi);
        
        var low = document.createElement('div');
        low.className='low';
        low.innerText = Weather.convertTemp(forecast.lo)+"º";
        
        tempD.appendChild(low);
        
        temps.appendChild(tempD)
        
        			
  			lastResults[i++] = {daycode:forecast.daycode, icon:forecast.icon, hi:forecast.hi, lo:forecast.lo};
  		}
  	}
  	
  	if(Settings.allowExpand && Settings.weather.allowExpand)
      Weather.Design.appendCustom('. . .','expand');
		
		Forecast.style.display = (Settings.weather.defState == 'shrinked' && Weather.neverUpdated || Weather.neverUpdated !== true && !Weather.expanded)?'none':'block';
		Weather.expanded=!(Settings.weather.defState == 'shrinked' && Weather.neverUpdated || Weather.neverUpdated !== true && !Weather.expanded);
		
		Weather.neverUpdated = new Date();
		Weather.nbTry = 0;
		
		setTimeout(Weather.weatherRefresherTemp.bind(Weather), 60*1000*Settings.weather.updateInterval);
	}
	else {
	 Weather.nbTry++;
	 
	 if(Weather.nbTry > 4 || Weather.Settings.dontInsist) {
	   Weather.nbTry = 0;
	   setTimeout(Weather.weatherRefresherTemp.bind(Weather), 60*1000*Settings.weather.updateInterval);
	 }
	 else
	   setTimeout(Weather.weatherRefresherTemp.bind(Weather), 60*1000*2);
	}
	
  if(Weather.neverUpdated !== true) {
	   if(!Weather.$('Updated')) {
	     var Updated = Weather.Design.generateCustom('','Updated','Updated');
	     Weather.$('Forecast').appendChild(Updated);
	     
	     if(!Weather.Settings.showLastUpdated)
	       Weather.$('Updated').style.display = 'none';
	   }
	   else {
	     var Updated = Weather.$('Updated');
	     Updated.innerHTML = '';
     }
     
     var temp = document.createDocumentFragment();
     
     if(Settings.useRelative) {
      var tt = document.createElement('span');
      tt.innerHTML = Weather.neverUpdated.relative();
      temp.appendChild(tt);
     }
     else
       temp.appendChild(document.createTextNode(Weather.neverUpdated.format($S('formatDate'))+' '+$S('dateDivider')+' '+Weather.neverUpdated.format($S('formatTime'))));
     
	   Updated.appendChild(temp);
  }
};

Weather.convertTemp = function (num)
{
	if (Weather.Settings.isCelsius === true || (Weather.Settings.isCelsius == 'default' && Controller.language.indexOf('en') == -1))
		return Math.round ((num - 32) * 5 / 9);
	else
		return num;
}

document.write('<script type="text/javascript" src="plugins/weather/Sources/'+Settings.weather.source+'.js"></script>');

Controller.registerPlugin(Weather);
